;This file is copyright (c) 1992 Informant Communications Group and the
;article author. The material here may be used in an application provided
;that this copyright/disclaimer information is kept in the original source
;file. The material presented here is provided "as is" and with no guarantee.
;Informant Communications Group/Paradox Informant assume no responsibility
;for the use or misuse of the material contained within.
;
;Contents        : Procedure ReverseLocate
;Source File     : REVSERCH.SC
;Author          : David R Faulkner
;                  Silver Software
;                  P O Box 434
;                  Maui, HI  96790
;                  (808) 878-2714
;
;Informant Issue : April 1992
;
;Description     : A procedure to locate a value from the bottom of a table.
;
; Paradox Informant
; 8525 Elk Grove Blvd.
; Suite 126
; Elk Grove, CA  95624-1777
; Phone: (916) 686-6610
; Fax  : (916) 686-8497
; BBS  : (916) 686-4740



Proc ReverseLocate(Value)
  Private BruteForceSize,  ;Max number of records to brute force search
          SearchSize,      ;Next increment of records to search
          Ceiling,         ;First record in search
          Floor            ;Last record in search

  BruteForceSize = -50         ;Brute force search at most 50 records
  SearchSize=BruteForceSize    ;Hope target record in last 50 records
  Ceiling=1;                   ;If all else fails, search from record 1

  end                          ;start at end of table
  GrowthFactor=max(int(([#]-Ceiling)/1000),2) ;calculate GrowthFactor

  while true
    Floor=[#]                          ;set floor to current record

    skip max(SearchSize, Ceiling-[#])  ;Skip to next locate point

    Locate Next Value                  ;Search from current record down
    Retval=Retval or []=Value          ;Set retval true if successful search

    switch
      case retval and SearchSize>=BruteForceSize:  ;time to brute force
        moveto record Floor
        while []<>Value
          up
        endwhile
        return true

      case retval:                                 ;found a record, now
        Ceiling=[#]                                ;narrow down search
        moveto record Floor
        GrowthFactor=max(int(([#]-Ceiling)/1000),2)
        SearchSize=BruteForceSize

      case atfirst():                              ;ReverseLocate failed
        return false

      otherwise:                                   ;Locate Next failed so
        SearchSize=GrowthFactor*SearchSize         ;increase search size

    endswitch
  endwhile
endproc



